<?php

namespace SRVX\Api\Controllers;

use SRVX\Model\SelfSupportForUserFaceInfo;
use SRVX\Msg;
use SRVX\Service\AliBPass\demo\AliEcoService;
use SRVX\Service\Pay\EasyAlipayService;
use SRVX\Service\Pay\PayService;
use SRVX\Traits\BasisFun;

class CallBackController extends \Phalcon\Mvc\Controller
{

    use BasisFun;

    /**
     * 支付宝 - 公共网关回调
     */
    public function cloudpayAliPayCallBackAction()
    {
        $args = $this->request->get();
        $this->logger($args, 'alipayCommonCallBack', true);
        if ($this->request->isPost()) {
            $this->logger($_POST, 'alipayCommonCallBack_post', true);
        }
        echo "success";
        die();
    }

    /**
     * 支付宝 - 公共异步回调
     */
    public function alipayAsyncNotifyCallBackAction()
    {
        if ($this->request->isPost()) {
            try {
                logger(json_encode([
                    "msg"  => "异步回调",
                    "data" => $_POST,
                ], 320), 'common_alipay_sync_notify', true);
                $self_order_sn = $_POST['out_trade_no'];            //商家业务订单号
                $trade_no      = $_POST['trade_no'];                     //支付宝交易号
                $trade_status  = $_POST['trade_status'];                     //交易状态

                //判断该笔订单是否在
                $model = UserMerchantOrder::findFirst("self_trade_no = '{$self_order_sn}'");
                if (!$model) {
                    //未查到訂單
                    logger(json_encode([
                        "msg"  => "异步回调失败-訂單未查到",
                        "data" => $_POST,
                    ], 320), 'common_alipay_sync_notify_not_find', true);
                    //验证失败
                    echo "fail";
                    die();
                }
                //商户网站中已经做过处理
                if ($model->status != IPay::PAY_STATE_FOR_WAIT) {
                    logger(json_encode([
                        "msg"  => "异步回调已处理",
                        "data" => $_POST,
                    ], 320), 'alipay_sync_notify_already', true);
                    echo "success";
                    die();
                }

                $model->return_data = json_encode($_POST);
                $model->trade_no    = $trade_no;
                $model->updated_at  = date("Y-m-d H:i:s");

                echo "success";
                die();
            } catch (\Exception $e) {
                logger(json_encode([
                    "msg"       => "异步回调處理异常",
                    "data"      => $params ?? [],
                    "exception" => $e->getMessage()
                ], 320), 'alipay_sync_notify_exception', true);
                //回調異常
                echo "fail";
                die();
            }
        }
    }
}